image: docker:latest
services:
- docker:dind

stages:
- publish

variables:
  IMAGE: registry.gitlab.com/investio-app/backend/c/public-api


build-docker-main:
  stage: publish
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
  script:
    - docker build -t ${IMAGE}:latest . --build-arg version="rc-$(date +%s)"
    - docker push $IMAGE
  only:
    - master
  # rules:
  #   - if: $CI_COMMIT_BRANCH == "master" || $CI_COMMIT_BRANCH == "main"

build-docker-release:
  stage: publish
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
  script:
    - docker build -t ${IMAGE}:${CI_COMMIT_TAG} . --build-arg version=${CI_COMMIT_TAG}
    - docker push $IMAGE:$CI_COMMIT_TAG
  only:
    - tags

# --- Manual push ---
# build-docker-dev:
#   stage: publish
#   before_script:
#     - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
#   script:
#     - docker build -t ${IMAGE}:dev . --build-arg version="dev-$(date +%s)"
#     - docker push ${IMAGE}:dev
#   only:
#     - dev